#include <stdio.h>
#include <Python.h>

#include "libnumarray.h"

int main(int argc, char *argv)
{
	PyObject *a;
	Int32    data[2][4] = {{ 0 , 1, 2, 3 }, {4, 5, 6, 7}};

	NA_Begin();  /* Init python and numarray. */
	

	/* Create a new 2D 2x4 array of Int32 referring to 'data'. */
	if ((a = NA_New(data, tInt32, 2, 2, 4))) {
		
		/* Add the array to itself and print the result. */
		PyObject_Print(PyNumber_Add(a,a), stdout, 0);
		printf("\n");
		fflush(stdout);

	} else {
		PyErr_Print();
		Py_FatalError("Array creation call failed...");
	}

	NA_End(); /* Finalize python and numarray. */
}

