
/*   W     W   AAA   RRRR   N   N  III  N   N   GGG   !!!
**   W     W  A   A  R   R  NN  N   I   NN  N  G   G  !!!
**   W  W  W  AAAAA  RRRR   N N N   I   N N N  G       !
**    W W W   A   A  R   R  N  NN   I   N  NN  G  GG
**     W W    A   A  R   R  N   N  III  N   N   GGG   !!!
**
** WARNING: This file is program generated by codegenerator.py.
**
** DO NOT EDIT THIS FILE! Any changes made to this file will be lost!
*/

#include <Python.h>
#include <stdio.h>
#include "libnumarray.h"
static PyObject *_Error;

/* These macros do byteswapping from an input buffer to an output buffer.
   The output buffer may or may not be the same as the input buffer, hence
   a temporary copy of the input is required.
*/

/* unaligned copy functions */
#define copy1(i, o)  *(o) = *(i);
#define copy2(i, o)  copy1(i, o); copy1(i+1, o+1);
#define copy4(i, o)  copy2(i, o); copy2(i+2, o+2);
#define copy8(i, o)  copy4(i, o); copy4(i+4, o+4);

#define swap1(i, o) copy1(i, o);
#define swap2(i, o) swap1(i, o+1); swap1(i+1, o);
#define swap4(i, o) swap2(i, o+2); swap2(i+2, o);
#define swap8(i, o) swap4(i, o+4); swap4(i+4, o);

/* aligned copy functions */
#define acopy1(i, o) ((Int8  *)o)[0] = ((Int8  *)i)[0];
#define acopy2(i, o) ((Int16 *)o)[0] = ((Int16 *)i)[0];
#define acopy4(i, o) ((Int32 *)o)[0] = ((Int32 *)i)[0];
#define acopy8(i, o) ((Float64 *)o)[0] = ((Float64 *)i)[0];
#define acopyN(i, o) memcpy(o, i, N);

#define MIN(x,y) (((x)<=(y)) ? (x) : (y))
#define MAX(x,y) (((x)>=(y)) ? (x) : (y))

/* The following is used to copy nbytes of data for each element.   **
** As such it can be used to align any sort of data provided the    **
** output pointers used are aligned                                 */

static int copyNbytes(long dim, long nbytes, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
    long i, j;
    char *tin  = (char *) input  + inboffset;
    char *tout = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            for (j=0; j<nbytes; j++) {
                *tout++ = *tin++;
            }
            tin = tin + inbstrides[dim] - nbytes;
            tout = tout + outbstrides[dim]- nbytes;
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            copyNbytes(dim-1, nbytes, niters,
                input,  inboffset  + i*inbstrides[dim],  inbstrides,
                output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(copyNbytes, !CHECK_ALIGN, -1, -1);

/* Copy a data buffer to a new string
**
** Arguments:
**
**   Tuple of iteration values for each dimension of input array.
**   Input buffer object.
**   Input byte offset.
**   Tuple of input byte strides.
**   Size of input data item in bytes.
**
** Returns Python string.
*/

static PyObject *copyToString(PyObject *self, PyObject *args) {
    PyObject *inbuffObj;
    PyObject *nitersObj, *inbstridesObj;
    PyObject *otemp, *outstring;

    int nniters, ninbstrides, nbytes, nargs;
    long niters[MAXDIM], inboffset, inbstrides[MAXDIM], outbstrides[MAXDIM];
    void *inbuffer, *outbuffer;
    long i, inbsize, outbsize;
    
    nargs = PyObject_Length(args);
    if (!PyArg_ParseTuple(args, "OOlOl",
            &nitersObj, &inbuffObj,  &inboffset, &inbstridesObj, &nbytes))
        return NULL;
    nniters = PyObject_Length(nitersObj);
    ninbstrides = PyObject_Length(inbstridesObj);
    if (nniters != ninbstrides)
        return NULL;
    for (i=nniters-1; i>=0; i--) {
        otemp = PySequence_GetItem(nitersObj, i);
        niters[nniters-i-1] = PyInt_AsLong(otemp);
        Py_DECREF(otemp);
        otemp = PySequence_GetItem(inbstridesObj, i);
        inbstrides[nniters-i-1] = PyInt_AsLong(otemp);
        Py_DECREF(otemp);
    }
    outbstrides[0] = nbytes;
    for (i=1; i<nniters; i++) {
        outbstrides[i] = outbstrides[i-1]*niters[i-1];
    }
    outbsize = outbstrides[nniters-1]*niters[nniters-1];
    outstring = PyString_FromStringAndSize(NULL, outbsize);
    if (!outstring)
        return NULL;
    outbuffer = (void *) PyString_AsString(outstring);
    if ((inbsize = NA_getBufferPtrAndSize(inbuffObj, 0, &inbuffer)) < 0)
       return PyErr_Format(_Error,
           "copyToString: Problem with array buffer (readonly?)");

    if (NA_checkOneStriding("copyToString", nniters-1, niters,
			  inboffset, inbstrides, inbsize, nbytes, 0) ||
	NA_checkOneStriding("copyToString", nniters-1, niters,
			  0, outbstrides, outbsize, nbytes, 0))
	    return NULL;

    copyNbytes(nniters-1, nbytes, niters,
          inbuffer, inboffset, inbstrides, outbuffer, 0, outbstrides);

    return outstring;
}

/* chooseXbytes functions are called as uFuncs... */

enum CLIP_MODE {
  CLIPPED,
  WRAPPED
};

#define wrap(i, max)      while(i < 0)             i += max;        while(i >= max)          i -= max;

static int chooseNbytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32 i, cMode, maxP, N, *selector;
  char **population, *output;
  int outi = ninargs + noutargs - 1;

  if (NA_checkIo("chooseNbytes", 2, 1, MIN(ninargs,2), noutargs))
     return -1;

  if (NA_checkOneCBuffer("chooseNbytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode        =  ((Int32 *) buffers[0])[0];
     N            =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("chooseNbytes", niter, buffers[1], bsizes[1], sizeof(Int32)))
     return -1;
  else
     selector     =  (Int32 *)  buffers[1];

  if (ninargs-2 == 0)
    return 0;
  else
    maxP = ninargs-2;
  for(i=2; i<ninargs; i++)
     if (NA_checkOneCBuffer("chooseNbytes", niter*N, buffers[i], bsizes[i], 1))
        return -1;
  population      =  (char **) &buffers[2];

  if (NA_checkOneCBuffer("chooseNbytes", niter*N, buffers[outi], bsizes[outi], 1))
     return -1;
  else
     output       =  (char *)   buffers[outi];

  switch(cMode)
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
	  wrap(j, maxP);
          memcpy( &output[i*N], &population[j][i*N], N);
        }
      break;
    default:
    case CLIPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
          if (j < 0)
            j = 0;
          else if (j >= maxP)
            j = maxP-1;
          memcpy( &output[i*N], &population[j][i*N], N);
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(chooseNbytes, CFUNC_UFUNC);

static int takeNbytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32  i, cMode, N, *scatteredstrides, *scatteredshape, **indices;
  char   *gathered, *scattered;
  int nindices = ninargs-4, outi = ninargs+noutargs-1;

  if (NA_checkIo("takeNbytes", 4, 1, MIN(ninargs, 4), noutargs))
     return -1;

  if (nindices == 0)
     return 0;
  
  if (NA_checkOneCBuffer("takeNbytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode            =  ((Int32 *) buffers[0])[0];
     N                =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("takeNbytes", niter*N, buffers[1], bsizes[1], 1))
     return -1;
  else
     scattered        =  (char *)   buffers[1];

  if (NA_checkOneCBuffer("takeNbytes", nindices, buffers[2], bsizes[2], sizeof(Int32)))
     return -1;
  else {
     scatteredstrides =  (Int32 *)  buffers[2];
  }
  
  if (NA_checkOneCBuffer("takeNbytes", nindices, buffers[3], bsizes[3], sizeof(Int32)))
     return -1;
  else {
     scatteredshape   =  (Int32 *)  buffers[3];
  }

  for(i=4; i<nindices; i++)
     if (NA_checkOneCBuffer("takeNbytes", niter, buffers[i], bsizes[i], sizeof(Int32)))
        return -1;
  indices          =  (Int32 **) &buffers[4];

  if (NA_checkOneCBuffer("takeNbytes", niter*N, buffers[outi], bsizes[outi], 1))
     return -1;
  else 
     gathered         =  (char *)  buffers[ninargs+noutargs-1];

  switch( cMode )
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          Int32 j, index;
          for(j=index=0; j<nindices; j++)
            {
              Int32 k = indices[j][i];
	      wrap(k, scatteredshape[j]);
              index += scatteredstrides[j]*k;
            }
          memcpy( &gathered[i*N], scattered+index, N);
        }
      break;
    case CLIPPED:
    default:
      for(i=0; i<niter; i++)
        {
          Int32 j, index;
          for(j=index=0; j<nindices; j++)
            {
              Int32 k = indices[j][i];
              if (k < 0)
                k = 0;
              else if (k >= scatteredshape[j])
                k = scatteredshape[j]-1;
              index += scatteredstrides[j]*k;
            }
          memcpy( &gathered[i*N], scattered+index, N);
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(takeNbytes, CFUNC_UFUNC);

static int putNbytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32  i, cMode, N, *scatteredstrides, *scatteredshape, **indices;
  char   *gathered, *scattered;
  int nindices = ninargs-4, outi = ninargs+noutargs-1;

  if (nindices == 0)
     return 0;
  
  if (NA_checkIo("putNbytes", 4, 1, MIN(ninargs, 4), noutargs))
     return -1;

  if (NA_checkOneCBuffer("putNbytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode            =  ((Int32 *) buffers[0])[0];
     N                =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("putNbytes", niter*N, buffers[1], bsizes[1], 1))
     return -1;
  else
     gathered          =  (char *)   buffers[1];

  if (NA_checkOneCBuffer("putNbytes", nindices, buffers[2], bsizes[2], sizeof(Int32)))
     return -1;
  else {
     scatteredstrides =  (Int32 *)  buffers[2];
  }
  
  if (NA_checkOneCBuffer("putNbytes", nindices, buffers[3], bsizes[3], sizeof(Int32)))
     return -1;
  else {
     scatteredshape   =  (Int32 *)  buffers[3];
  }

  for(i=4; i<nindices; i++)
     if (NA_checkOneCBuffer("putNbytes", niter, buffers[i], bsizes[i], sizeof(Int32)))
        return -1;
  indices          =  (Int32 **) &buffers[4];

  if (NA_checkOneCBuffer("putNbytes", niter*N, buffers[outi], bsizes[outi], 1))
     return -1;
  else 
     scattered         =  (char *)  buffers[outi];

  switch( cMode )
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          Int32 j, index;
          for(j=index=0; j<nindices; j++)
            {
              Int32 k = indices[j][i];
	      wrap(k, scatteredshape[j]);
              index += scatteredstrides[j]*k;
            }
          memcpy( scattered+index, &gathered[i*N], N);
        }
      break;
    case CLIPPED:
    default:
      for(i=0; i<niter; i++)
        {
          Int32 j, index;
          for(j=index=0; j<nindices; j++)
            {
              Int32 k = indices[j][i];
              if (k < 0)
                k = 0;
              else if (k >= scatteredshape[j])
                k = scatteredshape[j]-1;
              index += scatteredstrides[j]*k;
            }
          memcpy( scattered+index, &gathered[i*N], N);
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(putNbytes, CFUNC_UFUNC);

/****************** Int8 *******************/

/*******************************************
*                                          *
* These copy data to a contiguous buffer.  *
* They do not handle non-aligned data.     *
* Offsets and Strides are in byte units    *
*                                          *
*******************************************/

static int copy1bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
    long i;
    char *tin     = (char *) input  + inboffset;
    char *tout    = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            acopy1(tin, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            copy1bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(copy1bytes, CHECK_ALIGN, 1, 1);

static int align1bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
	return copyNbytes(dim, 1, niters, input, inboffset, inbstrides, 
			  output, outboffset, outbstrides);
}

STRIDING_DESCR2(align1bytes, !CHECK_ALIGN, 1, 1);

/******* byteswap *****/

static int byteswap1bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {

    long i;
    char *tin  = (char *) input  + inboffset;
    char *tout = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            char t[1];
            copy1(tin, t);
            swap1(t, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            byteswap1bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(byteswap1bytes, !CHECK_ALIGN, 1, 1);

static int choose1bytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32 i, cMode, maxP, N, *selector;
  Int8 **population, *output;
  int outi = ninargs + noutargs - 1;

  if (NA_checkIo("choose1bytes", 2, 1, MIN(ninargs,2), noutargs))
     return -1;

  if (NA_checkOneCBuffer("choose1bytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode        =  ((Int32 *) buffers[0])[0];
     N            =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("choose1bytes", niter, buffers[1], bsizes[1],
     sizeof(Int32)))
        return -1;
  else
     selector     =  (Int32 *)  buffers[1];

  if (ninargs-2 == 0)
    return 0;
  else
    maxP = ninargs-2;
  for(i=2; i<ninargs; i++)
     if (NA_checkOneCBuffer("choose1bytes", niter,
        buffers[i], bsizes[i], 1))
           return -1;
  population      =  (Int8 **) &buffers[2];

  if (NA_checkOneCBuffer("choose1bytes", niter,
     buffers[outi], bsizes[outi], 1))
        return -1;
  else
     output       =  (Int8 *)   buffers[outi];

  if (maxP == 0) 
	  return 0;

  switch(cMode)
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
	  wrap(j, maxP);
          output[i] = population[j][i];
        }
      break;
    default:
    case CLIPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
          if (j < 0)
            j = 0;
          else if (j >= maxP)
            j = maxP-1;
          output[i] = population[j][i];
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(choose1bytes, CFUNC_UFUNC);


/****************** Int16 *******************/

/*******************************************
*                                          *
* These copy data to a contiguous buffer.  *
* They do not handle non-aligned data.     *
* Offsets and Strides are in byte units    *
*                                          *
*******************************************/

static int copy2bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
    long i;
    char *tin     = (char *) input  + inboffset;
    char *tout    = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            acopy2(tin, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            copy2bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(copy2bytes, CHECK_ALIGN, 2, 2);

static int align2bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
	return copyNbytes(dim, 2, niters, input, inboffset, inbstrides, 
			  output, outboffset, outbstrides);
}

STRIDING_DESCR2(align2bytes, !CHECK_ALIGN, 2, 2);

/******* byteswap *****/

static int byteswap2bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {

    long i;
    char *tin  = (char *) input  + inboffset;
    char *tout = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            char t[2];
            copy2(tin, t);
            swap2(t, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            byteswap2bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(byteswap2bytes, !CHECK_ALIGN, 2, 2);

static int choose2bytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32 i, cMode, maxP, N, *selector;
  Int16 **population, *output;
  int outi = ninargs + noutargs - 1;

  if (NA_checkIo("choose2bytes", 2, 1, MIN(ninargs,2), noutargs))
     return -1;

  if (NA_checkOneCBuffer("choose2bytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode        =  ((Int32 *) buffers[0])[0];
     N            =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("choose2bytes", niter, buffers[1], bsizes[1],
     sizeof(Int32)))
        return -1;
  else
     selector     =  (Int32 *)  buffers[1];

  if (ninargs-2 == 0)
    return 0;
  else
    maxP = ninargs-2;
  for(i=2; i<ninargs; i++)
     if (NA_checkOneCBuffer("choose2bytes", niter,
        buffers[i], bsizes[i], 2))
           return -1;
  population      =  (Int16 **) &buffers[2];

  if (NA_checkOneCBuffer("choose2bytes", niter,
     buffers[outi], bsizes[outi], 2))
        return -1;
  else
     output       =  (Int16 *)   buffers[outi];

  if (maxP == 0) 
	  return 0;

  switch(cMode)
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
	  wrap(j, maxP);
          output[i] = population[j][i];
        }
      break;
    default:
    case CLIPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
          if (j < 0)
            j = 0;
          else if (j >= maxP)
            j = maxP-1;
          output[i] = population[j][i];
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(choose2bytes, CFUNC_UFUNC);


/****************** Int32 *******************/

/*******************************************
*                                          *
* These copy data to a contiguous buffer.  *
* They do not handle non-aligned data.     *
* Offsets and Strides are in byte units    *
*                                          *
*******************************************/

static int copy4bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
    long i;
    char *tin     = (char *) input  + inboffset;
    char *tout    = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            acopy4(tin, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            copy4bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(copy4bytes, CHECK_ALIGN, 4, 4);

static int align4bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
	return copyNbytes(dim, 4, niters, input, inboffset, inbstrides, 
			  output, outboffset, outbstrides);
}

STRIDING_DESCR2(align4bytes, !CHECK_ALIGN, 4, 4);

/******* byteswap *****/

static int byteswap4bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {

    long i;
    char *tin  = (char *) input  + inboffset;
    char *tout = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            char t[4];
            copy4(tin, t);
            swap4(t, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            byteswap4bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(byteswap4bytes, !CHECK_ALIGN, 4, 4);

static int choose4bytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32 i, cMode, maxP, N, *selector;
  Int32 **population, *output;
  int outi = ninargs + noutargs - 1;

  if (NA_checkIo("choose4bytes", 2, 1, MIN(ninargs,2), noutargs))
     return -1;

  if (NA_checkOneCBuffer("choose4bytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode        =  ((Int32 *) buffers[0])[0];
     N            =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("choose4bytes", niter, buffers[1], bsizes[1],
     sizeof(Int32)))
        return -1;
  else
     selector     =  (Int32 *)  buffers[1];

  if (ninargs-2 == 0)
    return 0;
  else
    maxP = ninargs-2;
  for(i=2; i<ninargs; i++)
     if (NA_checkOneCBuffer("choose4bytes", niter,
        buffers[i], bsizes[i], 4))
           return -1;
  population      =  (Int32 **) &buffers[2];

  if (NA_checkOneCBuffer("choose4bytes", niter,
     buffers[outi], bsizes[outi], 4))
        return -1;
  else
     output       =  (Int32 *)   buffers[outi];

  if (maxP == 0) 
	  return 0;

  switch(cMode)
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
	  wrap(j, maxP);
          output[i] = population[j][i];
        }
      break;
    default:
    case CLIPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
          if (j < 0)
            j = 0;
          else if (j >= maxP)
            j = maxP-1;
          output[i] = population[j][i];
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(choose4bytes, CFUNC_UFUNC);


/****************** Float64 *******************/

/*******************************************
*                                          *
* These copy data to a contiguous buffer.  *
* They do not handle non-aligned data.     *
* Offsets and Strides are in byte units    *
*                                          *
*******************************************/

static int copy8bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
    long i;
    char *tin     = (char *) input  + inboffset;
    char *tout    = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            acopy8(tin, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            copy8bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(copy8bytes, CHECK_ALIGN, 8, 8);

static int align8bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {
	return copyNbytes(dim, 8, niters, input, inboffset, inbstrides, 
			  output, outboffset, outbstrides);
}

STRIDING_DESCR2(align8bytes, !CHECK_ALIGN, 8, 8);

/******* byteswap *****/

static int byteswap8bytes(long dim, long dummy, long *niters,
            void *input,  long inboffset,  long *inbstrides,
            void *output, long outboffset, long *outbstrides) {

    long i;
    char *tin  = (char *) input  + inboffset;
    char *tout = (char *) output + outboffset;
    if (dim == 0) {
        for (i=0; i<niters[dim]; i++) {
            char t[8];
            copy8(tin, t);
            swap8(t, tout);
            tin  += inbstrides[dim];
            tout += outbstrides[dim];
        }
    }
    else {
        for (i=0; i<niters[dim]; i++) {
            byteswap8bytes(dim-1, dummy, niters,
               input,  inboffset  + i*inbstrides[dim],  inbstrides,
               output, outboffset + i*outbstrides[dim], outbstrides);
        }
    }
    return 0;
}

STRIDING_DESCR2(byteswap8bytes, !CHECK_ALIGN, 8, 8);

static int choose8bytes(long niter, long ninargs, long noutargs,
                         void **buffers, long *bsizes)
{
  Int32 i, cMode, maxP, N, *selector;
  Float64 **population, *output;
  int outi = ninargs + noutargs - 1;

  if (NA_checkIo("choose8bytes", 2, 1, MIN(ninargs,2), noutargs))
     return -1;

  if (NA_checkOneCBuffer("choose8bytes", 2, buffers[0], bsizes[0], sizeof(Int32)))
     return -1;
  else {
     cMode        =  ((Int32 *) buffers[0])[0];
     N            =  ((Int32 *) buffers[0])[1];
  }

  if (NA_checkOneCBuffer("choose8bytes", niter, buffers[1], bsizes[1],
     sizeof(Int32)))
        return -1;
  else
     selector     =  (Int32 *)  buffers[1];

  if (ninargs-2 == 0)
    return 0;
  else
    maxP = ninargs-2;
  for(i=2; i<ninargs; i++)
     if (NA_checkOneCBuffer("choose8bytes", niter,
        buffers[i], bsizes[i], 8))
           return -1;
  population      =  (Float64 **) &buffers[2];

  if (NA_checkOneCBuffer("choose8bytes", niter,
     buffers[outi], bsizes[outi], 8))
        return -1;
  else
     output       =  (Float64 *)   buffers[outi];

  if (maxP == 0) 
	  return 0;

  switch(cMode)
    {
    case WRAPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
	  wrap(j, maxP);
          output[i] = population[j][i];
        }
      break;
    default:
    case CLIPPED:
      for(i=0; i<niter; i++)
        {
          int j = selector[i];
          if (j < 0)
            j = 0;
          else if (j >= maxP)
            j = maxP-1;
          output[i] = population[j][i];
        }
      break;
    }
  return 0;
}

SELF_CHECKED_CFUNC_DESCR(choose8bytes, CFUNC_UFUNC);


static PyMethodDef _bytesMethods[] = {
	{ "copyToString", copyToString, METH_VARARGS},

	{NULL,      NULL}        /* Sentinel */
};

static PyObject *init_funcDict(void) {
    PyObject *dict;
    dict = PyDict_New();
    NA_add_cfunc(dict, "copy1bytes", (void *) &copy1bytes_descr);
    NA_add_cfunc(dict, "byteswap1bytes", (void *) &byteswap1bytes_descr);
    NA_add_cfunc(dict, "align1bytes", (void *) &align1bytes_descr);
    NA_add_cfunc(dict, "choose1bytes", (void *) &choose1bytes_descr);
    NA_add_cfunc(dict, "copy2bytes", (void *) &copy2bytes_descr);
    NA_add_cfunc(dict, "byteswap2bytes", (void *) &byteswap2bytes_descr);
    NA_add_cfunc(dict, "align2bytes", (void *) &align2bytes_descr);
    NA_add_cfunc(dict, "choose2bytes", (void *) &choose2bytes_descr);
    NA_add_cfunc(dict, "copy4bytes", (void *) &copy4bytes_descr);
    NA_add_cfunc(dict, "byteswap4bytes", (void *) &byteswap4bytes_descr);
    NA_add_cfunc(dict, "align4bytes", (void *) &align4bytes_descr);
    NA_add_cfunc(dict, "choose4bytes", (void *) &choose4bytes_descr);
    NA_add_cfunc(dict, "copy8bytes", (void *) &copy8bytes_descr);
    NA_add_cfunc(dict, "byteswap8bytes", (void *) &byteswap8bytes_descr);
    NA_add_cfunc(dict, "align8bytes", (void *) &align8bytes_descr);
    NA_add_cfunc(dict, "choose8bytes", (void *) &choose8bytes_descr);
    NA_add_cfunc(dict, "copyNbytes", (void *) &copyNbytes_descr);
    NA_add_cfunc(dict, "chooseNbytes", (void *) &chooseNbytes_descr);
    NA_add_cfunc(dict, "putNbytes", (void *) &putNbytes_descr);
    NA_add_cfunc(dict, "takeNbytes", (void *) &takeNbytes_descr);
    return dict;
}

/* platform independent*/
#ifdef MS_WIN32
__declspec(dllexport)
#endif
void init_bytes(void) {
    PyObject *m, *d;
    m = Py_InitModule("_bytes", _bytesMethods);
    d = PyModule_GetDict(m);
    _Error = PyErr_NewException("_bytes.error", NULL, NULL);
    PyDict_SetItemString(d, "error", _Error);
    import_libnumarray();
    PyDict_SetItemString(d, "functionDict", init_funcDict());
}
