
#include <Python.h>

#define _libnumarray_MODULE
#include "libnumarray.h"

#include "getndinfo.ch"
#include "buffer.ch"
#include "newarray.ch"
#include "cfunc.ch"

static PyObject *_libnumarrayError;

void *libnumarray_API[] = {
	(void*)getBuffer,
	(void*)isBuffer,
	(void*)getWriteBufferDataPtr,
	(void*)isBufferWriteable,
	(void*)getReadBufferDataPtr,
	(void*)getBufferSize,
	(void*)getNDInfo,
	(void*)getNumInfo,
	(void*)NA_Init,
	(void*)NA_Done,
	(void*)NA_NewAll,
	(void*)NA_New,
	(void*)NA_FromInfo,
	(void*)NA_FromLong,
	(void*)NA_FromDouble,
	(void*)NA_One,
	(void*)NA_Zero,
	(void*)NA_ConvertInput,
	(void*)NA_ShadowOutput,
	(void*)NA_ShadowOptionalOutput,
	(void*)NA_ConvertOutput,
	(void*)NA_ReturnShadowedOptionalOutput,
	(void*)NA_ShapeMisMatch,
	(void*)NA_getBufferPtrAndSize,
	(void*)NA_checkIo,
	(void*)NA_checkOneCBuffer,
	(void*)NA_checkNCBuffers,
	(void*)NA_checkOneStriding,
	(void*)NA_new_cfunc,
	(void*)NA_add_cfunc
};

static PyMethodDef _libnumarrayMethods[] = {
    {NULL,      NULL}        /* Sentinel */
};

/* platform independent*/
#ifdef MS_WIN32
__declspec(dllexport)
#endif

void initlibnumarray(void)
{
    PyObject *m = Py_InitModule("libnumarray", _libnumarrayMethods);
    PyObject *c_api_object;

    _libnumarrayError = PyErr_NewException("_libnumarray.error", NULL, NULL);

    /* Create a CObject containing the API pointer array's address */
    c_api_object = PyCObject_FromVoidPtr((void *)libnumarray_API, NULL);

    if (c_api_object != NULL) {
      /* Create a name for this object in the module's namespace */
      PyObject *d = PyModule_GetDict(m);

      PyDict_SetItemString(d, "_C_API", c_api_object);
      PyDict_SetItemString(d, "error", _libnumarrayError);
      Py_DECREF(c_api_object);
    }
}


